const NETWORK_TIMEOUT_TIME = 120;
const TWITTER_API_URL = "https://twitter.com/";

function Twitbin ()
{
     this.wm= Components.classes["@mozilla.org/appshell/window-mediator;1"]
                   .getService(Components.interfaces.nsIWindowMediator);
     this.mainWindow= this.wm.getMostRecentWindow("navigator:browser");

     this.ajax;
     this.generalArray=new Array(); //LO USO PARA GUARDAR EL HISTORIAL DE TWEETS
	 this.generalArray[2]= new Array(); // public
   	 this.generalArray[3]= new Array(); // friend
   	 this.generalArray[4]= new Array(); // D
   	 this.generalArray[5]= new Array(); // @
   	 this.generalArray[6]= new Array(); // fav

     this.generalVeces= new Array();
	 this.generalVeces[1]= 0; // cantidad de posts que hizo
	 this.generalVeces[2]= 0; // public todavia no entro nunca si es falso
	 this.generalVeces[3]= 0; // friend todavia no entro nunca si es falso
	 this.generalVeces[4]= 0; // D todavia no entro nunca si es falso
	 this.generalVeces[5]= 0; // @ todavia no entro nunca si es falso
	 this.generalVeces[6]= 0; // fav todavia no entro nunca si es falso

     this.toUpdate= new Array();      //contiene la lista de los nuevos tweets, los que son UPDATE
     this.nrosTweets= new Array();   //usado para mandar a las stats -received-

     this.setIntPointer; //var usada en el time interval del refresh
     this.setFolowInterval; //var usada para el refresh de followers y followings, se actualiza cada 30 min
     this.flagError=0;
     this.flagErrorAnterior=0;
     this.msgError= "Sorry, twitter has reached its hourly request limit on your account. Please hold tight, and make sure you aren't running any other twitter services with this username."; //mensaje por default
     this.typePendiente=''; //var usada para manejar las esperas de los tabs y refresh, dice quien quiere entrar
     this.isUpdating=0;   // 1= esta updating 0=no esta updating
     this.stopUpdating=0;   // 1= alquien quiere ejecutar 0=nadie queire ejecutar
     this.login_id='';
     this.fechaHora=''; //la uso en la funcion changeTime, la hora la saco justo antes de actualizar los tweets
     this.twitbinBase= new TwitbinBase;

     this.followersIds=new Array(); //guardo los id's de todos los followers para poder mandar un D
     this.setFollowersInterval; //var usado para la actualizacion del array que contiene los id's de los followers

}

Twitbin.prototype = {

//////////////////////////////////////////////////////
//													//
//		AJAX FOR TWEETS, AUTH, ADD/POST TWEETS      //
//													//
//////////////////////////////////////////////////////


validUrl: function (typeUrl)
{

	switch(parseInt(typeUrl))
	{
		case 1: //LOGIN
		url = "http://twitter.com/account/verify_credentials.xml?"+Math.random();
		break;

		case 2: //PUBLIC
		url = "http://twitter.com/statuses/public_timeline.xml?"+Math.random();
		break;

		case 3: //FRIEND
		url = "http://twitter.com/statuses/friends_timeline.xml?"+Math.random();

		break;

		case 4: //D
	    url = "http://twitter.com/direct_messages.xml?"+Math.random();
		break;

		case 5: //@
		url = "http://twitter.com/statuses/replies.xml?"+Math.random();
		break;

		case 6: //FAVS
		url="http://twitter.com/favorites.xml?"+Math.random();
		break;

		case 7: //POST
		url = 'http://twitter.com/statuses/update.xml?'+Math.random();
		break;

		case 8: //ADD TO FAV
		var id=twitbin1.readCookie("twitbin_id");
		url = 'http://twitter.com/favorites/create/'+id+'.xml?'+Math.random();
		break;

		case 9: //REMOVE OF FAV
		var id=twitbin1.readCookie("twitbin_id");
		url = 'http://twitter.com/favorites/destroy/'+id+'.xml?'+Math.random();
		break;

		case 10: //GET FOLLOWERS - FOLLOWINGS
		var user=twitbin1.readCookie("twitbin_user");
		url = 'http://twitter.com/users/show/'+user+'.xml?'+Math.random();
		break;

        case 11: //TWITBIN ADD AS FOLLOWING
		url = 'http://twitter.com/notifications/follow/twitbin.xml?'+Math.random();
		break;

        case 12: //TWITBIN LEAVE FOLLOWING
		url = 'http://twitter.com/notifications/leave/twitbin.xml?'+Math.random();
		break;

        case 13: //GET FOLLOWERS ID'S       {get}
		url = 'http://twitter.com/followers/ids.xml?'+Math.random();
		break;

        /*case 14: //SEND A REPLY TO A DIRECT MESSAGE      POST  {user + text}
		url = 'http://twitter.com/direct_messages/new.xml?'+Math.random();
		break;*/

	}

	return url;
},


param: function (value) //usado en fav
{
	twitbin1.createCookie('twitbin_id', value, 1);

    if(document.getElementById(value).style.backgroundImage  == "url(img/icon_link_2.jpg)") //no es fav  y ahora es
    {

        document.getElementById(value).style.backgroundImage ="url('img/icon_link_2_on.jpg')";
        document.getElementById(value).className='two2 screenshot4';
        document.getElementById(value).title="";
        document.getElementById(value).onmouseover=TwitbinScreenshotPreview4("Remove from favorites");
        document.getElementById(value).onclick= function onclick(event)
                                               {
                                                  twitbin1.param(value);

                                                  twitbin1.eliminarFav(value);
                                                  twitbin1.ajaxTwitbin(9);
                                               }
    }
    else  //Era fav y deja de ser
    {
        document.getElementById(value).style.backgroundImage ="url('img/icon_link_2.jpg')";
        document.getElementById(value).className='two2 screenshot5';
        document.getElementById(value).title="";
        document.getElementById(value).onmouseover=TwitbinScreenshotPreview5("Add to favorites");
        document.getElementById(value).onclick= function onclick(event)
                                               {
                                                    twitbin1.param(value);

                                                    twitbin1.agregarFavTweet(twitbin1.readCookie('twitbin_pref_type'), value);
                                                    twitbin1.ajaxTwitbin(8);
                                               }

    }
},

updateNewTweets: function () //SE USA PARA ACTUALIZAR LOS TWEETS NUEVOS, HACIENDOLOS APARECER DE A UNO, MANTENIENDO EL HISTORIAL
{

    var type=twitbin1.readCookie("twitbin_pref_type");



    if(twitbin1.stopUpdating==0)
    {
    	var tweet=twitbin1.toUpdate.pop(); //pop

        twitbin1.isUpdating=1; //esta updeteando

		var sponsor=0;
		var imgHeart='';
		var arrobaImg='';
        var reTweet='';
		var sourceFrom='';
        var inReplyTo='';
        var timeAgo='';
		var row="";
        var dMsg='';

		if (tweet)
		{
            //twitbin1.quickSort(twitbin1.generalArray[parseInt(type)]);
            twitbin1.handleLimitOfArray(type);//public - 60; friend - 160;

			if(tweet[1]!='no') //me fijo que no sea un eliminado de la seccion fav
			{
				if ((twitbin1.isUserLoged() == true) && (document.getElementById('logout').style.display=='block')) //el usuario
				{
					if (parseInt(type) != 4)//no es D
					{

						if (tweet[4]!='false') // el tweet es fav
						{

                            imgHeart="<li class='last'><a img id='"+tweet[0]+"' href='#' class='two2 screenshot3' title='Remove from favorites' style='background-image:url(img/icon_link_2_on.jpg);' onclick='twitbin1.param("+tweet[0]+"); twitbin1.eliminarFav("+tweet[0]+"); twitbin1.ajaxTwitbin(9); '></a></li>";

						}
						else
						{
							if (tweet[4]=='false') //el tweet no es fav
							{
								x=tweet[0];
                                imgHeart="<li class='last'><a id='"+tweet[0]+"' href='#' class='two2 screenshot3' title='Add to favorites'  style='background-image:url(img/icon_link_2.jpg);' onclick=' twitbin1.param("+tweet[0]+"); twitbin1.agregarFavTweet("+twitbin1.readCookie('twitbin_pref_type')+", "+tweet[0]+"); twitbin1.ajaxTwitbin(8); '></a></li>";

							}
						}

						sourceFrom=" from "+ tweet[3];

                        arrobaImg="<li><a href='#' class='three3 screenshot3' title='Reply message' onclick='twitbin1.createCookie(\"twitbin_in_replay_to\","+tweet[0]+",1); document.getElementById(\"tweeeet\").value=\"\"; $(\"div#number\").html(- "+ (140 - (" @"+tweet[5]).length) +"); document.getElementById(\"tweeeet\").value+= \"@"+tweet[5]+" \"; document.getElementById(\"tweeeet\").focus();'></a></li>";

                        if((parseInt(type) !=2)&&(tweet[8]!= ''))
                        {
                            inReplyTo="<a href='#' style='color:#999999; text-decoration:none;' class='inReplyTo' onclick='twitbin1.openUrl(\"http://www.twitter.com/"+ tweet[9] + "/status/"+tweet[8]+"\");'>in reply to this</a>";
                        }

                        timeAgo="<span class='blueone' style='cursor:pointer;' onclick='twitbin1.openUrl(\"http://www.twitter.com/"+ tweet[5] + "/status/"+tweet[0]+"\");'>"+twitbin1.changeTime(tweet[1])+"</span>";

                      if(twitbin1.followersIds.indexOf(tweet[10]) != -1) // es follower
                      {
                          dMsg="<li class='last'><a href='#' class='five5 screenshot2' title='Direct message' onclick='document.getElementById(\"tweeeet\").value=\"\"; $(\"div#number\").html(- "+ (140 - (" D "+tweet[5]).length) +"); document.getElementById(\"tweeeet\").value+= \"D "+tweet[5]+" \"; document.getElementById(\"tweeeet\").focus();'></a></li>";
                      }
  				   }
                   else
                   {
                        arrobaImg="<li class='last'><a href='#' class='three3 screenshot3' title='Reply message' onclick='twitbin1.createCookie(\"twitbin_in_replay_to\","+tweet[0]+",1); document.getElementById(\"tweeeet\").value=\"\"; $(\"div#number\").html(- "+ (140 - (" @"+tweet[5]).length) +"); document.getElementById(\"tweeeet\").value+= \"@"+tweet[5]+" \";document.getElementById(\"tweeeet\").focus();'></a></li>";
                        timeAgo="<span class='blueone'>"+twitbin1.changeTime(tweet[1])+"</span>";

                        if(twitbin1.followersIds.indexOf(tweet[10]) != -1) // es follower
                        {
                               dMsg="<li><a href='#' class='five5 screenshot2' title='Direct message' onclick='document.getElementById(\"tweeeet\").value=\"\"; $(\"div#number\").html(- "+ (140 - (" D "+tweet[5]).length) +"); document.getElementById(\"tweeeet\").value+= \"D "+tweet[5]+" \"; document.getElementById(\"tweeeet\").focus();'></a></li>";
                        }
                   }

                    var b = /"/g;

                    var pepe=tweet[2].replace(b, '\\\"');
                    b=/'/g;
                    pepe=pepe.replace(b, '\u00b4');

                    reTweet="<li><a href='#' class='one1 screenshot3' title='Reetweet message' onclick='document.getElementById(\"tweeeet\").value=\"\"; $(\"div#number\").html(- "+ (140 - (("RT "+tweet[2]).length + ("@ "+tweet[5]).length)) +"); document.getElementById(\"tweeeet\").value+= \"RT @"+tweet[5]+" "+pepe+"\" '></a></li>";

				}
                else
                {
                   sourceFrom=" from "+ tweet[3];
                   timeAgo="<span class='blueone' style='cursor:pointer;' onclick='twitbin1.openUrl(\"http://www.twitter.com/"+ tweet[5] + "/status/"+tweet[0]+"\");'>"+twitbin1.changeTime(tweet[1])+"</span>";
                }

               //HANDLE SOURCE LINK ON TAB
               var aaa=sourceFrom.indexOf('http://');
               if(aaa != -1)
               {
                    var ppp=sourceFrom.indexOf('">');
                    var hhh=sourceFrom.substring(aaa, ppp);
                    sourceFrom=sourceFrom.replace('href="'+hhh+'"','href="#" onclick="twitbin1.openUrl(\''+ hhh + '\');" ');
               }

				var finalText=twitbin1.convertToLink("http://", tweet[2]); finalText=twitbin1.convertToLink("https://", finalText); finalText=twitbin1.arrobaLink(finalText);

                row=row+"<div class='tweets'><div class='profile'><a href='#' onclick='twitbin1.openUrl(\"http://www.twitter.com/"+tweet[5]+ "\");'><img class='img' src='"+tweet[6]+ "' border='0' alt='' width='32' height='32'/></a>";
                row=row+'<ul>'+reTweet+imgHeart+arrobaImg+dMsg+'</ul>';
                row=row+'</div><div class="burble"><div class="lefttop"></div><div class="righttop"></div><div class="leftbottom"></div><div class="rightbottom"></div>';
                row=row+"<div class='border'><span><span><a href='#' onclick='twitbin1.openUrl(\"http://www.twitter.com/"+tweet[5]+ "\");'>"+tweet[5].toUpperCase()+"</a></span></span><div class='div'>"+finalText+" "+timeAgo+sourceFrom+" "+inReplyTo+"</div></div></div></div>";

			}

			sponsor++;

			$("#tweetss").prepend(row);
		} //end if chequeo de que haya algo

		if (twitbin1.toUpdate.length > 0)
		{
			setTimeout(twitbin1.updateNewTweets, 2000);

		}
		else
        {
            twitbin1.isUpdating=0;  /*alert("termino"); */
             TwitbinScreenshotPreview3(); //PONE LAS BURBLE
        }

   }//end if updating
   else
   { //stop updating
      twitbin1.toUpdate.pop(); //pop
      twitbin1.deleteFromUpdateArray(parseInt(type));  //BORRAR DEL ARRAY GRANDE LOS TWEETS QUE NO SE VIERON
      twitbin1.isUpdating=0;
      TwitbinScreenshotPreview3(); //PONE LAS BURBLE
      twitbin1.stopUpdating=0;
      twitbin1.startActions(parseInt(twitbin1.typePendiente));  //hago el llamado con el type que interrumpio
   }



},


addAllTweets: function (tweets) //UNICA FUNCION QUE AGREGA CADA ROW EN EL TWEET VIEW
{
	$(".tweetss").remove();
	var row="";
	$("#list").append('<div class="tweetss" id="tweetss"></div>'); //esto


	var type=twitbin1.readCookie("twitbin_pref_type");

	var sponsor=0;

    twitbin1.quickSort(tweets);

	for (var i=0; i< tweets.length ;i++ )
	{
		var imgHeart='';
		var arrobaImg='';
        var reTweet='';
		var sourceFrom='';
        var inReplyTo='';
        var timeAgo='';
        var dMsg='';
		row="";


        // alert("sponsor: " + sponsor + " i: " + i);
	    //if((sponsor==19) || (i== 19) || ((tweets.length <= 21)&& (i==tweets.length -1)))
        if((sponsor==19)  || ((tweets.length <= 20)&& (i==tweets.length -1)))
		{
            row=row+"<div class='tweets'><div class='profile'><a href='#'><img class='img' src='img/twitbin_bigger.gif' onclick='twitbin1.openUrl(\"http://www.twitbin.com/\");' border='0' alt='' width='32' height='32' /></a>";
            var aux="";
            if ((twitbin1.isUserLoged() == true) && (document.getElementById('logout').style.display=='block')) //el usuario
			{
              row=row+"<ul><li><a href='#' class='three3 screenshot2' title='Reply message' onclick='document.getElementById(\"tweeeet\").value=\"\"; $(\"div#number\").html(- "+ (140 - "@twitbin ".length) +"); document.getElementById(\"tweeeet\").value+= \"@twitbin \" '></a></li><li class='last'><a href='#' class='four4 screenshot2' title='Go to Twitbin.com' onclick='twitbin1.openUrl(\"http://www.twitbin.com/\");'></a></li></ul>";
              aux="(</span><a href='#' onclick='twitbin1.ajaxTwitbin(11);'>FOLLOW?</a><span>)";
            }
            else
            {
                row=row+"<ul><li><a href='#' class='four4 screenshot2' title='Go to Twitbin.com' onclick='twitbin1.openUrl(\"http://www.twitbin.com/\");'></a></li></ul>";

            }

            row=row+"</div><div class='burble_yellow'><div class='lefttop'></div><div class='righttop'></div><div class='leftbottom'></div><div class='rightbottom'></div>";
            row=row+"<div class='border'><span>TWITBIN <span>"+aux+"</span><span></span></span><div class='div'><a href='#' onclick='twitbin1.openUrl(\"http://twitbin.com/advertising/\");'>Advertise on twitbin!</a></div></div></div></div>";

            sponsor=0;
		}

		if(tweets[i][1]!='no') //me fijo que no sea un eliminado de la seccion fav
		{

			if ((twitbin1.isUserLoged() == true) && (document.getElementById('logout').style.display=='block')) //el usuario
			{
				if (parseInt(type) != 4)//no es D
				{

					if (tweets[i][4]!='false') // el tweet es fav
					{
                        imgHeart="<li class='last'><a id='"+tweets[i][0]+"' href='#' class='two2 screenshot2' title='Remove from favorites' style='background-image:url(img/icon_link_2_on.jpg);' onclick='twitbin1.param("+tweets[i][0]+"); twitbin1.eliminarFav("+tweets[i][0]+"); twitbin1.ajaxTwitbin(9);' ></a></li>";
					}
					else
					{
						if (tweets[i][4]=='false') //es tweet no es fav
						{
							x=tweets[i][0];
                            imgHeart="<li class='last'><a id='"+tweets[i][0]+"' href='#' class='two2 screenshot2' title='Add to favorites'   style='background-image:url(img/icon_link_2.jpg);' onclick='twitbin1.param("+tweets[i][0]+"); twitbin1.agregarFavTweet("+twitbin1.readCookie('twitbin_pref_type')+", "+tweets[i][0]+"); twitbin1.ajaxTwitbin(8); '></a></li>";
						}
					}
					sourceFrom=" from "+ tweets[i][3];

                    arrobaImg="<li><a href='#' class='three3 screenshot2' title='Reply message' onclick='twitbin1.createCookie(\"twitbin_in_replay_to\","+tweets[i][0]+",1); document.getElementById(\"tweeeet\").value=\"\"; $(\"div#number\").html(- "+ (140 - (" @"+tweets[i][5]).length) +"); document.getElementById(\"tweeeet\").value+= \"@"+tweets[i][5]+" \"; document.getElementById(\"tweeeet\").focus();'></a></li>";

                    //info_tweets[8]=$("in_reply_to_status_id", this).text();
                    //info_tweets[9]=$("in_reply_to_screen_name", this).text();

                    timeAgo="<span class='blueone' style='cursor:pointer;' onclick='twitbin1.openUrl(\"http://www.twitter.com/"+ tweets[i][5] + "/status/"+tweets[i][0]+"\");'>"+twitbin1.changeTime(tweets[i][1])+"</span>";

                    if((parseInt(type) !=2)&&(tweets[i][8]!= ''))
                    {
                      inReplyTo="<a href='#' style='color:#999999; text-decoration:none;' class='inReplyTo' onclick='twitbin1.openUrl(\"http://www.twitter.com/"+ tweets[i][9] + "/status/"+tweets[i][8]+"\");'>in reply to this</a>";
                    }

                    if(twitbin1.followersIds.indexOf(tweets[i][10]) != -1) // es follower
                    {
                         dMsg="<li class='last'><a href='#' class='five5 screenshot2' title='Direct message' onclick='document.getElementById(\"tweeeet\").value=\"\"; $(\"div#number\").html(- "+ (140 - (" D "+tweets[i][5]).length) +"); document.getElementById(\"tweeeet\").value+= \"D "+tweets[i][5]+" \"; document.getElementById(\"tweeeet\").focus();'></a></li>";
                    }
				}
                else
                {
                    arrobaImg="<li class='last'><a href='#' class='three3 screenshot2' title='Reply message' onclick='twitbin1.createCookie(\"twitbin_in_replay_to\","+tweets[i][0]+" , 1); document.getElementById(\"tweeeet\").value=\"\"; $(\"div#number\").html(- "+ (140 - (" @"+tweets[i][5]).length) +"); document.getElementById(\"tweeeet\").value+= \"@"+tweets[i][5]+" \"; document.getElementById(\"tweeeet\").focus();'></a></li>";
                    timeAgo="<span class='blueone'>"+twitbin1.changeTime(tweets[i][1])+"</span>";

                    if(twitbin1.followersIds.indexOf(tweets[i][10]) != -1) // es follower
                    {
                       dMsg="<li><a href='#' class='five5 screenshot2' title='Direct message' onclick='document.getElementById(\"tweeeet\").value=\"\"; $(\"div#number\").html(- "+ (140 - (" D "+tweets[i][5]).length) +"); document.getElementById(\"tweeeet\").value+= \"D "+tweets[i][5]+" \"; document.getElementById(\"tweeeet\").focus();'></a></li>";
                    }
                }

                var b = /"/g;

                var pepe=tweets[i][2].replace(b, '\\\"');
                b=/'/g;
                pepe=pepe.replace(b, '\u00b4');

               reTweet="<li><a href='#' class='one1 screenshot2' title='Reetweet message' onclick='document.getElementById(\"tweeeet\").value=\"\"; $(\"div#number\").html(- "+ (140 - (("RT "+tweets[i][2]).length + (" @"+tweets[i][5]).length)) +"); document.getElementById(\"tweeeet\").value= \"RT @"+tweets[i][5]+" "+pepe+"\" '></a></li>";


			}
            else
            {
              sourceFrom=" from "+ tweets[i][3];
              timeAgo="<span class='blueone' style='cursor:pointer;' onclick='twitbin1.openUrl(\"http://www.twitter.com/"+ tweets[i][5] + "/status/"+tweets[i][0]+"\");'>"+twitbin1.changeTime(tweets[i][1])+"</span>";
            }

           //HANDLE SOURCE LINK ON TAB
           var aaa=sourceFrom.indexOf('http://');
           if(aaa != -1)
           {
                var ppp=sourceFrom.indexOf('">');
                var hhh=sourceFrom.substring(aaa, ppp);
                sourceFrom=sourceFrom.replace('href="'+hhh+'"','href="#" onclick="twitbin1.openUrl(\''+ hhh + '\');" ');
           }


			var finalText=twitbin1.convertToLink("http://", tweets[i][2]); finalText=twitbin1.convertToLink("https://", finalText); finalText=twitbin1.arrobaLink(finalText);

            row=row+"<div class='tweets'><div class='profile'><a href='#' onclick='twitbin1.openUrl(\"http://www.twitter.com/"+tweets[i][5]+ "\");'><img class='img' src='"+tweets[i][6]+ "' border='0' alt='' width='32' height='32'/></a>";
            row=row+'<ul>'+reTweet+imgHeart+arrobaImg+dMsg+'</ul>';
            row=row+'</div><div class="burble"><div class="lefttop"></div><div class="righttop"></div><div class="leftbottom"></div><div class="rightbottom"></div>';
            row=row+"<div class='border'><span><span><a href='#' onclick='twitbin1.openUrl(\"http://www.twitter.com/"+tweets[i][5]+ "\");'>"+tweets[i][5].toUpperCase()+"</a></span></span><div class='div'>"+finalText+" "+timeAgo+sourceFrom+" "+inReplyTo+"</div></div></div></div>";

        }

		$("#tweetss").prepend(row);

		sponsor++;
	}//end for

    //MANEJO DE ERROR
   twitbin1.handleError();

   TwitbinScreenshotPreview2(); //PONE LAS BURBLE
},

make_base_auth: function ()
{

  var tok = twitbin1.readCookie("twitbin_user") + ':' + twitbin1.readCookie("twitbin_pass");
  var hash = twitbin1.twitbinBase.myUrlEncode(tok);
  return "Basic " + hash;
} ,

handleError: function ()     //MANEJO DE ERROR
{
    //MANEJO DE ERROR
    if ((twitbin1.flagError!=0) || ((twitbin1.flagErrorAnterior!=0) && ((parseInt(twitbin1.readCookie("twitbin_type"))== 8) || (parseInt(twitbin1.readCookie("twitbin_type"))== 9))))
	{
        twitbin1.errorVisible(twitbin1.msgError);
		if (twitbin1.flagErrorAnterior==0)
		{
			twitbin1.flagErrorAnterior=twitbin1.flagError;
		}
		twitbin1.flagError=0;
		twitbin1.hide('pref1'); twitbin1.hide('transparent');
	}
	else{twitbin1.errorHide(); twitbin1.flagErrorAnterior=twitbin1.flagError;}
},

ajaxTwitbin: function (type)
{

	// Creamos el control XMLHttpRequest segun el navegador en el que estemos
		var auth=""; var cual="GET"; var datos="";

		if(parseInt(type)!= 2)
		{
			twitbin1.createCookie("twitbin_user", document.getElementById('txtUsername').value, 7);
			twitbin1.createCookie("twitbin_pass", document.getElementById('txtPassword').value, 7);
			auth=twitbin1.make_base_auth();
		}

		twitbin1.createCookie("twitbin_type", type, 1);

		//ocultarMsgError();

		if (parseInt(type) == 1) //login
		{
			var xhr = new HttpRequest;
			xhr.setURI(twitbin1.validUrl(type));
			xhr.setRedirectLimitation(0);
			xhr.setRequestHeader("Authorization", auth);
			xhr.setRequestHeader('X-Twitter-Client', 'Twitbin');
			xhr.setRequestHeader('X-Twitter-Client-Version', '2.0');
			xhr.setRequestHeader('X-Twitter-Client-URL', 'http://www.twitbin.com');
			xhr.setRequestHeader("Cookie", "");
			xhr.onload = function(e) {

						var	parser=new DOMParser();
						datos=parser.parseFromString(xhr.responseText,"text/xml");
						if (!($("error", datos).text()))
						{
								twitbin1.hide('pref1'); twitbin1.hide('transparent');
								twitbin1.show('logout');
								document.getElementById('tweeeet').readOnly=false;
                                twitbin1.generalArray[2]= Array(); // public, reinicializo el historial
		                        twitbin1.generalVeces[2]= 0; // public, pongo contador de visitas a cero

                                var aux=twitbin1.readCookie("twitbin_url_transf",aux,1);  //me fijo si habia apretado tweet this!

                                if((aux != null) && (aux!= ''))
                                {
                                    document.getElementById('tweeeet').value=aux;
                                    document.getElementById('number').firstChild.nodeValue="- " + (140 - aux.length);
                                    twitbin1.eraseCookie("twitbin_url_transf",aux,1);
                                }

                                var ult =twitbin1.readCookie('twitbin_pref_type_login');

								if(ult == null){ult=3;}	//si no habia nada por default va a friends

   								twitbin1.ajaxTwitbin(13); //Actualizo el array de followers

								twitbin1.createCookie('twitbin_pref_type', ult, 1);
								twitbin1.ajaxTwitbin(10); //Llamo a actualizar las stats

                                twitbin1.startActions(ult);

                                twitbin1.check_prefs();  //Actualiza pref
  								twitbin1.sendStats('login');

                                twitbin1.followOnLogin(); //me fijo si se cliqueo el follow

						}
						else {
								twitbin1.createCookie('twitbin_chkRemember','no',7);
								twitbin1.flagError=1;
							    twitbin1.msgError="Unfortunately we couldn't verify your username or password, please enter them below and try again";
								twitbin1.logout(0);
                                twitbin1.createCookie('twitbin_pref_type',2, 1);
                                twitbin1.startActions(2);

							 }

		};

		 xhr.asyncOpen(true);
	  }
	  else{

				if(type==7 || type == 8 || type==9 || type==11 || type==12){cual="POST";}else{cual="GET";}
				if(type==7){datos="&source=twitbin&in_reply_to_status_id="+twitbin1.readCookie('twitbin_in_replay_to')+"&status="+encodeURIComponent(document.getElementById("tweeeet").value);}

				var xhr= $.ajax({

						url: twitbin1.validUrl(type),
						type: cual,
						data: datos,
						beforeSend : function(xhr) { //estado 1

											xhr.setRequestHeader('Authorization', auth);
											xhr.setRequestHeader('X-Twitter-Client', 'Twitbin');
											xhr.setRequestHeader('X-Twitter-Client-Version', '2.0');
											xhr.setRequestHeader('X-Twitter-Client-URL', 'http://www.twitbin.com');
											xhr.setRequestHeader("Cookie", "");

                                            twitbin1.show('ajaxRefresh'); //Muestra el circulito girar al lado de la cant de caracteres disponibles para tipear


						},
						error: function (xhr, textStatus, errorThrown) { //estado 4

								if ($("error", xhr.responseXML).text() == "Rate limit exceeded. Clients may not make more than 100 requests per hour.")
								{
									twitbin1.flagError=1;
									twitbin1.msgError="Sorry, twitter has reached its hourly request limit on your account. Please hold tight, and make sure you aren't running any other twitter services with this username.";

									$("#stats").remove();
									$("#statistic").append("<div id='stats'>Stats: not available</div>");
									self.clearInterval(twitbin1.setFolowInterval);
									twitbin1.setFolowInterval = self.setInterval("twitbin1.ajaxTwitbin(10)", 3 * 60 * 1000);
								}
								else
								{
									twitbin1.flagError=1;
									twitbin1.msgError="Oops! Seems like Twitter isn't responding right now. Try again in a few minutes.";
                                       // alert($("error", xhr.responseXML).text());

								}

                                twitbin1.hide('ajaxRefresh'); //Oculta el circulito girar al lado de la cant de caracteres disponibles para tipear

								var ult =twitbin1.readCookie('twitbin_pref_type');

								if(ult == null){ult=2;}	//si no habia nada por default va a public

								twitbin1.desactivar(ult);
								twitbin1.createCookie('twitbin_pref_type', ult, 1);
								twitbin1.refresh();
								//twitbin1.ajaxTwitbin(10); //Llamo a actualizar las stats
								twitbin1.addAllTweets(twitbin1.generalArray[ult]);
						},
						processData:false,
						success: function(datos){	 //estado 4

								//info_tweets[0]--> id_msg;
								//info_tweets[1]--> created;
								//info_tweets[2]--> text;
								//info_tweets[3]--> soruce;
								//info_tweets[4]--> favorited;
								//info_tweets[5]--> screen_name;
								//info_tweets[6]--> image;
								//info_tweets[7]--> url;
								//info_tweets[8]--> in_reply_to_status_id;
								//info_tweets[9]--> in_reply_to_screen_name;
                                //info_tweet[10]--> id_user

								switch(parseInt(type))
								{
									case 4:  //D

                                       	var action='';
										twitbin1.toUpdate=Array(); //ARRAY QUE CONTIENE TODOS LOS TWEETS A UPDATE, ARRAY GENERICO

										var tweets = twitbin1.generalArray[parseInt(type)]; //obtengo los tweets existentes

										twitbin1.generalVeces[parseInt(type)]++; //sumo en uno las veces que actualizo

										if (twitbin1.generalArray[parseInt(type)].length > 0) //se esta actualizando el tab
										{
											action="update"; //
											//twitbin1.addAllTweets(tweets); //agrego el historial
										}
										else {action="new"; }

										$("direct_message", datos).each(function(){

											var info_tweets = Array();
											info_tweets[0]=$("id", this).text();
                                            info_tweets[1]=$("created_at", this).text();
											var hoy=twitbin1.isTweetFromToday($("created_at", this).text());
											info_tweets[2]=$("text", this).text();
											info_tweets[3]="null";
											info_tweets[4]="null";

											var cleanTextId=info_tweets[0];

											$("sender", this).each(function(){
												var userId=$("id", this).text();
                                                info_tweets[10]=userId;
												info_tweets[0]=cleanTextId.replace(userId,"");

												if(hoy==true){twitbin1.addTweetNro(info_tweets[0]);}//agrego el nro de tweet para las stats

												info_tweets[5]=$("screen_name", this).text();
												info_tweets[6]=$("profile_image_url", this).text();
												info_tweets[7]=$("url", this).text();
											});

											var ok=twitbin1.checkIfExist(type, info_tweets[0]); //chequeo si el post ya existe en el array general


                                            if(ok==false) //no existe
    										{
    												//LO QUE HACE ESTO ES AGREGAR TODO AL HISTORIAL, SI ES UN UPDATE LOS AGREGO PERO NO SE MUESTRAN, DE ESO SE ENCARGA EL LLAMADO A LA FUNCION UPDATE, QUE HACE QUE APAREZCAN UNO POR UNO, LA PROX VEZ QUE SE ACTUALICE, LOS AGREGADOS ANTERIORMENTE EN "UPDATE" SE VAN A MOSTRAR DE UNA Y LOS NUEVOS UPDATE VAN A IR APARECIENDO DE A UNO

    												if (twitbin1.generalVeces[parseInt(type)]!= 1){ //ya actualice al menos una vez, ingreso los nuevos adelante

    												   	tweets.unshift(info_tweets);
    													twitbin1.toUpdate.push(info_tweets); //se usa en el update
    												}
    												else {
    													//es la 1era vez y no existe nada antes, ingreso uno atras del otro
    													tweets.push(info_tweets);
    												}

    										}
    									});

                                        twitbin1.fechaHora=(new Date).getTime(); //seteo la hora por la que voy a comprar el time ago de cada tweet

    									if (action =="update")
    									{

                                            twitbin1.quickSort(tweets);

                                            var auxToUpdate=new Array();
                                            for(var i=0; i<= twitbin1.toUpdate.length -1; i++)
                                            {
                                                auxToUpdate[i]=tweets.pop(); //saco los que agregue  y los agrego al nuevo array
                                            }

                                            auxToUpdate=twitbin1.quickSort(auxToUpdate);
                                            twitbin1.toUpdate=new Array();
                                            twitbin1.toUpdate=auxToUpdate;//copio los que van a actualizar nuevamente a toUpdate
                                            twitbin1.addAllTweets(tweets); //agrego el historial
                                            twitbin1.toUpdate=twitbin1.toUpdate.reverse();

                                            for(var i=0; i<= twitbin1.toUpdate.length -1; i++)
                                            {
                                              tweets.push(twitbin1.toUpdate[i]); //vuelvo a agregar los que saque
                                            }

										    twitbin1.updateNewTweets();
    									}

    									if (action == "new")
    									{
    										twitbin1.generalArray[parseInt(type)]=tweets;
    										twitbin1.addAllTweets(tweets);
    									}

									break;
									case 7: //post
										twitbin1.generalVeces[1]++;
                                        twitbin1.eraseCookie("twitbin_in_replay_to");
                                        document.getElementById("tweeeet").value = "";

										$("div#number").html(- 140);
                                        if(parseInt(twitbin1.readCookie('twitbin_pref_type')) == 3){twitbin1.startActions(3);}
										break;

									case 8: //add to fav
										twitbin1.eraseCookie("twitbin_id");
										break;

									case 9: //remove of fav
										twitbin1.eraseCookie("twitbin_id");
										break;

									case 10: //get followers- followings
										$("user", datos).each(function(){

											var followers=$("followers_count", this).text();
											var followings=$("friends_count", this).text();
											$("#stats2").remove();
											$("#statistic2").append("<div id='stats2'><strong>Stats: </strong><a href='#' onclick='twitbin1.openUrl(\"http://twitter.com/"+twitbin1.readCookie('twitbin_user')+"/friends\");'>"+ followings +" following</a> | <a href='#' onclick='twitbin1.openUrl(\"http://twitter.com/"+twitbin1.readCookie('twitbin_user')+"/followers\");'>"+ followers +" followers</a></div>");
											self.clearInterval(twitbin1.setFolowInterval);
											twitbin1.setFolowInterval = self.setInterval("twitbin1.ajaxTwitbin(10)", 30 * 60 * 1000);
										});
										break;

                                    case 11: //add twitbin as followings
                                             twitbin1.createCookie('twitbin_following', "si", 30);
                                             document.getElementById('twitbinFollow').checked=true;
                                             document.getElementById('twitbinFollow2').checked=true;
										break;

                                    case 12: //leave twitbin from followings
                                             twitbin1.createCookie('twitbin_following', "no", 30);
										break;

                                    case 13: //get all followers id's
                                            $("id", datos).each(function(){
                                                 var idx = twitbin1.followersIds.indexOf($(this).text());
                                                  if (parseInt(idx) == -1)
                                                  {
                                                       twitbin1.followersIds.push($(this).text());
                                                  }
                                            });
                                            self.clearInterval(twitbin1.setFollowersInterval);
											twitbin1.setFollowersInterval = self.setInterval("twitbin1.ajaxTwitbin(13)", 30 * 60 * 1000);
                                        break;

									default: //2-public, 3-friend, 5-@, 6-fav

										var action='';
										twitbin1.toUpdate= new Array(); //ARRAY QUE CONTIENE TODOS LOS TWEETS A UPDATE, ARRAY GENERICO

										var tweets = twitbin1.generalArray[parseInt(type)]; //obtengo los tweets existentes

										twitbin1.generalVeces[parseInt(type)]++; //sumo en uno las veces que actualizo

										if ((twitbin1.generalArray[parseInt(type)].length > 0)  && (twitbin1.generalVeces[parseInt(type)]!= 1))//se esta actualizando el tab
										{
											action="update"; //
											//twitbin1.addAllTweets(tweets); //agrego el historial
										}
										else {action="new"; }

										$("status", datos).each(function(){

											var info_tweets = new Array();
											info_tweets[0]=$("id", this).text();
											info_tweets[1]=$("created_at", this).text();

											var hoy=false; //solo cambia de valor si es @ y tiene fecha de hoy

											if(parseInt(type)==5){hoy=twitbin1.isTweetFromToday($("created_at", this).text());}

											info_tweets[2]=$("text", this).text();
											info_tweets[3]=$("source", this).text();
											info_tweets[4]=$("favorited", this).text();

                                            if(parseInt(type)!=2) //en public no funciona
                                            {
											    info_tweets[8]=$("in_reply_to_status_id", this).text();
											    info_tweets[9]=$("in_reply_to_screen_name", this).text();
                                            }

											var cleanTextId=info_tweets[0];
											$("user", this).each(function(){
												var userId=$("id", this).text();
                                                info_tweets[10]=userId;
												info_tweets[0]=cleanTextId.replace(userId,"");

												if(hoy==true){twitbin1.addTweetNro(info_tweets[0]);}//agrego el nro de tweet para las stats

												info_tweets[5]=$("screen_name", this).text();
												info_tweets[6]=$("profile_image_url", this).text();
												info_tweets[7]=$("url", this).text();
											});

											var ok=twitbin1.checkIfExist(parseInt(type), info_tweets[0]); //chequeo si el post ya existe en el array general

                                            twitbin1.fechaHora=(new Date).getTime(); //seteo la hora por la que voy a comprar el time ago de cada tweet

											if(ok==false) //no existe
											{
												//LO QUE HACE ESTO ES AGREGAR TODO AL HISTORIAL, SI ES UN UPDATE LOS AGREGO PERO NO SE MUESTRAN, DE ESO SE ENCARGA EL LLAMADO A LA FUNCION UPDATE, QUE HACE QUE APAREZCAN UNO POR UNO, LA PROX VEZ QUE SE ACTUALICE, LOS AGREGADOS ANTERIORMENTE EN "UPDATE" SE VAN A MOSTRAR DE UNA Y LOS NUEVOS UPDATE VAN A IR APARECIENDO DE A UNO

												if (twitbin1.generalVeces[parseInt(type)]!= 1){ //ya actualice al menos una vez, ingreso los nuevos adelante

												   	tweets.unshift(info_tweets); //ya no importa si es un unshift o push
													twitbin1.toUpdate.push(info_tweets); //se usa en el update
												}
												else {
													//es la 1era vez y no existe nada antes, ingreso uno atras del otro
													tweets.push(info_tweets);
												}

											}
										});

										if (action =="update")
										{
                                            twitbin1.quickSort(tweets);

                                            var auxToUpdate=new Array();
                                            for(var i=0; i<= twitbin1.toUpdate.length -1; i++)
                                            {
                                                auxToUpdate[i]=tweets.pop(); //saco los que agregue  y los agrego al nuevo array
                                            }

                                            auxToUpdate=twitbin1.quickSort(auxToUpdate);
                                            twitbin1.toUpdate=new Array();
                                            twitbin1.toUpdate=auxToUpdate;//copio los que van a actualizar nuevamente a toUpdate
                                            twitbin1.addAllTweets(tweets); //agrego el historial
                                            twitbin1.toUpdate=twitbin1.toUpdate.reverse();

                                            for(var i=0; i<= twitbin1.toUpdate.length -1; i++)
                                            {
                                              tweets.push(twitbin1.toUpdate[i]); //vuelvo a agregar los que saque
                                            }

										    twitbin1.updateNewTweets();
										}

										if (action == "new")
										{
											twitbin1.generalArray[parseInt(type)]=tweets;
											twitbin1.addAllTweets(tweets);
										}


									break;
								}

                                twitbin1.hide('ajaxRefresh'); //Oculta el circulito girar al lado de la cant de caracteres disponibles para tipear

						}


				}); //end ajax


		}//end else

},

startActions: function (who)
{
    if(who == 0) //saca de cookies
    {
        who=twitbin1.readCookie('twitbin_pref_type');
    }

    if(twitbin1.isUpdating==1) //esta actualizando, pone todo en 'orden' y sigue
    {
        twitbin1.stopUpdating=1;
        twitbin1.typePendiente=who;  //ehh loco quiero entrar yo-.-- WHO
          // isUpdating=0;
    }
    else  //esta todo correcto, llama al ajax
    {
        twitbin1.refresh();
        twitbin1.ajaxTwitbin(who);
        twitbin1.desactivar(who);
    }
},

deleteFromUpdateArray: function (who)
{
  //BORRA DEL ARRAY GENERICO CORRESPONDIENTE, LOS TWEETS DEL ARRAY UPDATE QUE NO SE LLEGARON A MOSTRAR

  var tweet=twitbin1.toUpdate.pop();

  if (tweet)
  {
      var id_tweet=tweet[0];

      var allTweets=twitbin1.generalArray[who];
      var ok=false;
      var j=0;

      while ((j < allTweets.length) && (ok==false))
      {

      	if (allTweets[j][0] == id_tweet)
      	{
      		ok=true;
      	    allTweets.splice(j,1);
      	}
      	else {j++;}

      }

      if (twitbin1.toUpdate.length > 0)
      {
  	     twitbin1.deleteFromUpdateArray(who);
      }
  }

},

updateStatusTextCharCounter: function (value, key)
{
		//CAPTURE ENTER HERE AND SEND TWEET

		if (key == 13)
        {
            if (document.getElementById("tweeeet").value != "")
            {
                twitbin1.ajaxTwitbin(7);
                twitbin1.show("logout");



            }
            return false;

        }


        //IF COUNTING REMOVE RETURN
        if ((140 - value.length) >= 0)
		{
			$("div#number").html("- " + (140 - value.length));
            if ($("div#number").html()== "- 140"){twitbin1.eraseCookie("twitbin_in_replay_to");}
		}
		else
		{$("div#number").html(- 140);}

},

//////////////////////////////////////////////////////
//													//
//					   MISC		                    //
//													//
//////////////////////////////////////////////////////

errorVisible: function (msg)
{
   $("#two_error").html(msg);
   document.getElementById("item_error").style.display="block";
   document.getElementById("list").style.top="113px";
},

errorHide: function ()
{
    $("#two_error").html("");
    document.getElementById("item_error").style.display="none";
    document.getElementById("list").style.top="70px";
},

isVisible: function (objName)
{
	if(document.getElementById(objName).style.display=="block")
	{
		return true;
	}
	else{return false;}
},

show: function (objName)
{
	document.getElementById(objName).style.display="block";//""
},

hide: function (objName)
{
	document.getElementById(objName).style.display="none";
},

refresh: function ()
{

	var ult=twitbin1.readCookie('twitbin_pref_type');  //  alert(ult);
	var reload_time = twitbin1.readCookie("twitbin_reload_time");

	self.clearInterval(twitbin1.setIntPointer);
	twitbin1.setIntPointer = self.setInterval("twitbin1.ajaxTwitbin("+ult+")", reload_time * 60 * 1000);
},

update_prefs: function ()
{
	//FIJA EL TIEMPO DE CADA CUANTO VA A SER EL REFRESH DE LA SECTION
	 var reload_time="";
     var pref_login="";

     switch(parseInt(document.getElementById('Refresh').value))
	 {
         case 15: reload_time = 15;
				break;
		 case 10: reload_time = 10;
				break;
		 case 8: reload_time = 8;
		        break;
		 case 5: reload_time = 5;
				break;
		 case 3: reload_time = 3;
				break;
         case 2: reload_time = 2;
				break;
     }

	 if (document.getElementById('View_0').checked == true)
		{ pref_login = 3;} //friend
        else
		{
			if (document.getElementById('View_1').checked == true)
            {
				pref_login = 5; //@
			} else {
					if (document.getElementById('View_2').checked == true)
					{
						pref_login = 4; //D
					} else {

							if (document.getElementById('View_3').checked == true)
							{
								pref_login = 6; //fav
							}
							else {pref_login = 2;} //public
						}
			}

		}

    if((twitbin1.readCookie('twitbin_following')=='no') && (document.getElementById('twitbinFollow').checked==true))
    {
          twitbin1.ajaxTwitbin(11);
          document.getElementById('twitbinFollow').checked=true;
          document.getElementById('twitbinFollow2').checked=true;
    }
    else
    {
          if((twitbin1.readCookie('twitbin_following')=='si') && (document.getElementById('twitbinFollow').checked==false))
          {
                    twitbin1.ajaxTwitbin(12);
                    document.getElementById('twitbinFollow').checked=false;
                    document.getElementById('twitbinFollow2').checked=false;
          }
    }


	twitbin1.createCookie("twitbin_reload_time", reload_time , 30);
    twitbin1.createCookie('twitbin_pref_type_login', pref_login, 30);  //guardo cual quiero que sea el inicio por default
},

followOnLogin: function()
{
    if((twitbin1.readCookie('twitbin_following')=='no') && (document.getElementById('twitbinFollow2').checked==true))
      {
            twitbin1.ajaxTwitbin(11);
            document.getElementById('twitbinFollow').checked=true;
            document.getElementById('twitbinFollow2').checked=true;
      }
      else
      {
            if((twitbin1.readCookie('twitbin_following')=='si') && (document.getElementById('twitbinFollow2').checked==false))
            if((twitbin1.readCookie('twitbin_following')=='si') && (document.getElementById('twitbinFollow2').checked==false))
            {
                      twitbin1.ajaxTwitbin(12);
                      document.getElementById('twitbinFollow').checked=false;
                      document.getElementById('twitbinFollow2').checked=false;
            }
      }
},

check_prefs: function()
{
	//ACTUALIZA SEGUN LA COOKIE CUAL ES EL TIEMPO QUE EL USUARIO ELIGIO
	var reload_time=twitbin1.readCookie("twitbin_reload_time");
    var pref_login=twitbin1.readCookie("twitbin_pref_type_login");


	if (( reload_time != null)||(reload_time== ''))
	{
		switch(parseInt(reload_time))
		{
			case 15: document.getElementById('Refresh').options[0].selected="selected";
				break;
			case 10: document.getElementById('Refresh').options[1].selected="selected";
				break;
			case 8: document.getElementById('Refresh').options[2].selected="selected";
				break;
			case 5: document.getElementById('Refresh').options[3].selected="selected";
				break;
			case 3: document.getElementById('Refresh').options[4].selected="selected";
				break;
            case 2: document.getElementById('Refresh').options[5].selected="selected";
				break;
		}
	}
	else
	{
	    document.getElementById('Refresh').options[4].selected="selected";
		twitbin1.createCookie("twitbin_reload_time", 3 , 30);
	}

    if (( pref_login != null)||(pref_login== ''))
	{
       	switch(parseInt(pref_login))
		{
			case 2: document.getElementById('View_4').checked = true;
				break;
			case 3: document.getElementById('View_0').checked = true;
				break;
			case 4: document.getElementById('View_2').checked = true;
				break;
			case 5: document.getElementById('View_1').checked = true;
				break;
			case 6: document.getElementById('View_3').checked = true;
				break;
		}
    }
    else
	{
	    document.getElementById('View_0').checked = true;
		twitbin1.createCookie("twitbin_pref_type_login", 3 , 30);
	}

   if(twitbin1.readCookie('twitbin_following')=='si')
    {
           document.getElementById('twitbinFollow').checked=true;
           document.getElementById('twitbinFollow2').checked=true;
           twitbin1.createCookie("twitbin_following", 'si' , 30);
    }
    else {
            document.getElementById('twitbinFollow').checked=false;
            document.getElementById('twitbinFollow2').checked=false;
            twitbin1.createCookie("twitbin_following", 'no' , 30);
    }
},

month: function  (month)
{
	switch (month)
	{
		case 'Jan': return '00'; break;
		case 'Feb': return '01'; break;
		case 'Mar': return '02'; break;
		case 'Apr': return '03'; break;
		case 'May': return '04'; break;
		case 'Jun': return '05'; break;
		case 'Jul': return '06'; break;
		case 'Aug': return '07'; break;
		case 'Sep': return '08'; break;
		case 'Oct': return '09'; break;
		case 'Nov': return '10'; break;
		case 'Dec': return '11'; break;

	}
},

isTweetFromToday: function (tweetDate)
{
	TwitterFecha=new Date(tweetDate.slice(26, 30), twitbin1.month(tweetDate.slice(4, 7)),tweetDate.slice(8, 10)); //saco del formato twitter me crea esto Sat Dec 27 2008 00:00:00 GMT-0300

	pepe2=new Date();
	LocalFecha=new Date(pepe2.getFullYear(), pepe2.getMonth(), pepe2.getDate()); //Thu Nov 27 2008 15:51:22 GMT-0300  Thu Nov 27 2008 00:00:00 GMT-0300
	return (TwitterFecha.getTime() == LocalFecha.getTime());
},

addTweetNro: function (nro)
{
	var ok=false;
	var p=0;

	while ((ok== false) && (p < twitbin1.nrosTweets.length))
	{
		if (parseInt(twitbin1.nrosTweets[p])==parseInt(nro))
		{
			ok=true;
		}
		p++;
	}

	if (ok==false)
	{
		twitbin1.nrosTweets.push(parseInt(nro));
	}
},

changeTime: function (time_value)
{
	//PARSEA EL TIEMPO
	var delta = parseInt((twitbin1.fechaHora - Date.parse(time_value)) / 1000);

	if ( delta < ( 60 ) ) {	return ( parseInt(delta) ).toString() + 'S ago';}
				else if ( delta < (3600 ) ) {return ( parseInt(delta / 60) ).toString() + 'Min ago';}
					else if ( delta < ( 86400) ) {return ( parseInt(delta / 3600) ).toString() + 'H ago';}
						else if ( delta < ( 604800 ) ) { return ( parseInt(delta / 86400) ).toString() + 'D ago';}
							else if ( delta < ( 2419200 ) ) {return ( parseInt(delta / 604800) ).toString() + 'W ago';}
									else if ( delta < ( 31536000 ) ) {return ( parseInt(delta / 2419200) ).toString() + 'M ago';}
										else return ( parseInt(delta / 31536000) ).toString() + 'Y ago';
},

isUserLoged: function()
{
	//CHEQUEA SI HAY ALGUNA SESION INICIADA

	var user=twitbin1.readCookie("twitbin_user");
	var pass=twitbin1.readCookie("twitbin_pass");
	if ((user== null) || (user== ''))
		{return false;}
	else
    {
			if((user==document.getElementById('txtUsername').value) && (pass==document.getElementById('txtPassword').value))
             {
                document.getElementById('txtUsername').value=user;
                document.getElementById('txtPassword').value=pass;
                twitbin1.createCookie("twitbin_user", user, 7);
			    twitbin1.createCookie("twitbin_pass", pass, 7);     //alert(user + pass + " 1 ");
             }
             else
             {
                if((document.getElementById('txtUsername').value=='') || (document.getElementById('txtUsername').value=='undefined') ||(document.getElementById('txtUsername').value==null))
                {
                    document.getElementById('txtUsername').value=user;
                    document.getElementById('txtPassword').value=pass;
                }
                 else{
                        user=document.getElementById('txtUsername').value;
                        pass= document.getElementById('txtPassword').value;
                  }
                 twitbin1.createCookie("twitbin_user", user, 7);
			     twitbin1.createCookie("twitbin_pass", pass, 7);      //alert(user + pass + " 2 ");
             }


			return true;
	}
},

logout: function (flag)
{

	if (flag==1)  //solo se ejecuta cuando el usuario hace logout cliqueando el link
	{

		document.getElementById('txtUsername').value="";
		document.getElementById('txtPassword').value="";
		document.getElementById('tweeeet').value="Tweet tweet";
        document.getElementById('number').firstChild.nodeValue="- " + (140 - document.getElementById('tweeeet').value.length);
		document.getElementById('tweeeet').readOnly=true;


		twitbin1.createCookie('twitbin_pref_type',2, 1);
        twitbin1.startActions(2);
        twitbin1.hide('logout');

	    twitbin1.sendStats('logout'); //guardo stats en al db

		twitbin1.nrosTweets= Array();
		twitbin1.generalArray[2]= Array(); // public
		twitbin1.generalArray[3]= Array(); // friend
		twitbin1.generalArray[4]= Array(); // D
		twitbin1.generalArray[5]= Array(); // @
		twitbin1.generalArray[6]= Array(); // fav
		twitbin1.generalVeces[2]= 0; // public todavia no entro nunca si es falso
		twitbin1.generalVeces[1]= 0;
		twitbin1.generalVeces[3]= 0; // friend todavia no entro nunca si es falso
		twitbin1.generalVeces[4]= 0; // D todavia no entro nunca si es falso
		twitbin1.generalVeces[5]= 0; // @ todavia no entro nunca si es falso
		twitbin1.generalVeces[6]= 0; // fav todavia no entro nunca si es falso

		$("#stats2").remove();
		$("#statistic2").append("<div id='stats2'>Login to see your stats</div>");

	}
    else
    {   //cerro el navegador o sidebar sin hacer logout cliqueando en el link

        if ((flag==0) && (document.getElementById('logout').style.display=='block'))
        {
               twitbin1.sendStats('logout'); //guardo stats en al db
        }

    }

    //borro las funciones que se ejecutan cada x tiempo
    self.clearInterval(twitbin1.setFolowInterval);
    self.clearInterval(twitbin1.setFollowersInterval);
    twitbin1.followersIds= new Array();

	var rem=twitbin1.readCookie("twitbin_chkRemember");
      // alert(rem);
	if (rem != "yes")
	{
		twitbin1.eraseCookie("twitbin_user");
		twitbin1.eraseCookie("twitbin_pass");
	}
    else
    {
        var user=twitbin1.readCookie("twitbin_user");
	    var pass=twitbin1.readCookie("twitbin_pass");
        document.getElementById('txtUsername').value=user;
		document.getElementById('txtPassword').value=pass;
    }

    twitbin1.hide('pref1');
    twitbin1.hide('pref2');
    twitbin1.hide('transparent');
},

desactivar: function (cualNo)
{
	switch(parseInt(cualNo))
	{
		case 2:
			document.getElementById("friend").className=""; document.getElementById("arroba").className="";
			document.getElementById("direct").className=""; document.getElementById("favo").className="heart";
			document.getElementById("public").className="on";
			break;
		case 3:
			document.getElementById("public").className=""; document.getElementById("arroba").className="";
			document.getElementById("direct").className=""; document.getElementById("favo").className="heart";
			document.getElementById("friend").className="on";
			break;
		case 4:
			document.getElementById("friend").className=""; document.getElementById("public").className="";
			document.getElementById("arroba").className=""; document.getElementById("favo").className="heart";
			document.getElementById("direct").className="on";
			break;
		case 5:
			document.getElementById("friend").className=""; document.getElementById("public").className="";
			document.getElementById("direct").className=""; document.getElementById("favo").className="heart";
			document.getElementById("arroba").className="on";
			break;
		case 6:
			document.getElementById("friend").className=""; document.getElementById("public").className="";
			document.getElementById("arroba").className=""; document.getElementById("direct").className="";
			document.getElementById("favo").className="heart on"; //document.getElementById("favo").style.backgroundColor="#551a8b";
			break;
	}
},



getServerAddress: function()
{
    //return window.location.protocol + '//' + window.location.hostname + '/tweetbin'; //beta
	return window.location.protocol + '//' + window.location.hostname + '/twitbin20';

},

//////////////////////////////////////////////////////
//													//
//			 ORDENACION Y LIMITES DEL VECTOR        //
//													//
//////////////////////////////////////////////////////

quickSort: function (objArray)
{
    return objArray.sort(twitbin1.procesoQuickSort);
},

procesoQuickSort: function (a,b)
{
    return parseInt(Date.parse(a[1])) - parseInt(Date.parse(b[1])); //ordeno por fechas
    //return parseInt(a[0]) - parseInt(b[0]);  //ordeno por tweet id
},

handleLimitOfArray: function (type)
{
   switch (parseInt(type))
   {
       case 2://public
            if(twitbin1.generalArray[2].length >40)
            {
                 twitbin1.generalArray[2].shift();
            }
         break;
       case 3://friend

            if(twitbin1.generalArray[3].length >140)
            {
                   twitbin1.generalArray[3].shift();
            }
        break;
   }
},

//////////////////////////////////////////////////////
//													//
//					   FAVS		                    //
//													//
//////////////////////////////////////////////////////

checkIfExist: function (type, id_tweet)
{
	//CHEQUEA SI UN TWEET YA EXISTE EN EL HISTORIAL DE TWEET

	var allTweets=twitbin1.generalArray[type];
	var ok=false;
	var j=0;
	while ((j < allTweets.length) && (ok==false))
	{
		if (allTweets[j][0] == id_tweet)
		{
			ok=true;
		}
		j++;
	}

	return ok;
},

agregarFavTweet: function (type, id_tweet)
{
	//Actualiza algun tweet de acuerdo al tipo y su id, por ejemplo para decir que ese tweet ya no es mas favorito
	var allTweets=twitbin1.generalArray[type];
	var ok=false;
	var j=0;

	while ((j < allTweets.length) && (ok==false))
	{
		if (allTweets[j][0] == id_tweet)
		{
			ok=true;
			allTweets[j][4]='true';
		}
		else {j++;}

	}

    if (twitbin1.checkIfExist(6, id_tweet) == false) //si no existia en los fav section, lo agrego
	{
    	var info_tweets = Array();
    		info_tweets[0]=allTweets[j][0];
    		info_tweets[1]=allTweets[j][1];
    		info_tweets[2]=allTweets[j][2];
        	info_tweets[3]=allTweets[j][3];
            info_tweets[4]=allTweets[j][4];
            info_tweets[5]=allTweets[j][5];
          	info_tweets[6]=allTweets[j][6];
          	info_tweets[7]=allTweets[j][7];
          	info_tweets[8]=allTweets[j][8];
          	info_tweets[9]=allTweets[j][9];
          	info_tweets[10]=allTweets[j][10];

           //agrega el fav modificado en al posicion indicada
           twitbin1.generalArray[6].unshift(info_tweets);
   }


  twitbin1.generalArray[type]=allTweets;
  twitbin1.generalArray[type]=twitbin1.quickSort(twitbin1.generalArray[type]);
  //  twitbin1.addAllTweets(allTweets);

}, //end function

eliminarFav: function (id_tweet)
{
	//paso por todas las section para estar segura que el tweet fav ya no esta mas fav
	twitbin1.eliminarFavTweet (2, id_tweet);
	twitbin1.eliminarFavTweet (3, id_tweet);
	twitbin1.eliminarFavTweet (5, id_tweet);
    twitbin1.eliminarFavTweet (6, id_tweet);

 //	twitbin1.addAllTweets(twitbin1.generalArray[twitbin1.readCookie('twitbin_pref_type')]); //actualizo los tweets en la section en la que estaba
},

eliminarFavTweet: function  (type, id_tweet)
{
	//Por ahora lo que hace es solo eliminar un tweet de los favoritos, en el type mandando y en fav section

	if (type!=6)
	{

		var allTweets=twitbin1.generalArray[type];
		var ok=false;
		var j=0;
		while ((j < allTweets.length) && (ok==false))
		{
			if (allTweets[j][0] == id_tweet)
			{
				ok=true;
				allTweets[j][4]='false';
			}
			else{j++;}

		}

		twitbin1.generalArray[type]=allTweets;
	}
	else
	{
		if (twitbin1.checkIfExist(6, id_tweet) == true) //si existia en los fav, lo marco para que no se use
		{
			var allTweetsFav=twitbin1.generalArray[6];
			var m=0; var okFav=false;
			while ((m < allTweetsFav.length) && (okFav==false))
			{
				if (allTweetsFav[m][0] == id_tweet)
				{
					okFav=true;
					allTweetsFav[m][0]="no";
					allTweetsFav[m][1]="no";
					allTweetsFav[m][2]="no";
					allTweetsFav[m][3]="no";
					allTweetsFav[m][4]="no";
					allTweetsFav[m][5]="no";
					allTweetsFav[m][6]="no";
					allTweetsFav[m][7]="no";
					allTweetsFav[m][8]="no";
					allTweetsFav[m][9]="no";
					allTweetsFav[m][10]="no";

				}else{m++;}

			}

			//agrega el fav modificado
			twitbin1.generalArray[6]=allTweetsFav;
		}
        if(parseInt(twitbin1.readCookie('twitbin_pref_type'))==6){twitbin1.addAllTweets(twitbin1.generalArray[6]);}   //si el ultimo tab cliqueado fue fav

	}

} ,


//////////////////////////////////////////////////////
//													//
//					   COOKIES	                    //
//													//
//////////////////////////////////////////////////////

eraseCookie: function (name)
{
    	twitbin1.createCookie(name, '', -1);
},

createCookie: function (name,value,days)
{
	//crea cookies
	var ios = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
    var cookieUri = ios.newURI("http://www.twitbin.com/", null, null);
    var cookieSvc = Components.classes["@mozilla.org/cookieService;1"].getService(Components.interfaces.nsICookieService);
	var expires="";

	if (days)
	{
		var date = new Date();
			date.setTime(date.getTime()+(days*24*60*60*1000));
		expires = date.toGMTString();
	}

	if ((name=="twitbin_user") || (name=="twitbin_pass"))
	{
		value=twitbin1.twitbinBase.myUrlEncode(value);
	}

	var cookieString = name+ "="+value+";domain=.twitbin.com;expires=" + expires;
    cookieSvc.setCookieString(cookieUri, null, cookieString, null);

},

readCookie: function (name) //FUNCIONA
{

	//lee cookies
	var cookieMgr = Components.classes["@mozilla.org/cookiemanager;1"]
				 .getService(Components.interfaces.nsICookieManager);

	for (var e = cookieMgr.enumerator; e.hasMoreElements();) {
	  var cookie = e.getNext().QueryInterface(Components.interfaces.nsICookie);
		// alert(cookie.host + " ; " + cookie.name + " = " + cookie.value + "\n"); // see http://developer.mozilla.org/en/docs/nsICookie for a list of attributes on |cookie|

		if(cookie.name == name)
		{
			if ((name=="twitbin_user") || (name=="twitbin_pass"))
			{
				return twitbin1.twitbinBase.myUrlDecode(cookie.value);
			}
			else{ return cookie.value;}
		}
	}
	return null;
},


//////////////////////////////////////////////////////
//													//
//			   LINKS AND @ CONVERTIONS              //
//													//
//////////////////////////////////////////////////////
takeUrls: function (text)
{
   var pat = /((http(s?))\:\/\/)([0-9a-zA-Z\-]+\.)+[a-zA-Z]{2,6}(\:[0-9]+)?(\/([\w#!:.?+=&%@~*\';,\-\/\$])*)?/g;
   var re = /[.,;:]$/;
   while (pat.exec(text) != null) {
      var left = RegExp.leftContext;
      var url = RegExp.lastMatch;
      text = RegExp.rightContext;
      if (re.test(url)) {
            text = RegExp.lastMatch + text;
            url = url.replace(re, '');
      }
   }
   return url;
},

convertToLink: function (str, text)
{ //ESTA FUNCION LO QUE HACE ES CONVERTIR LOS LINKS CON TEXTO EXPLICITO EN LINK>>

			var indice=1; var noTermino=false; var inicio=0; var cantidad=0; var newtext='';
			var anterior=0; var e=''; var s='';
			while (noTermino==false)
			{


				var s = text.indexOf(str, inicio);
				if (s >= 0)
				{	//alert(s);
					e = text.indexOf(" ", s + 1);
					if (e != -1) //no termino el texto
					{

						indice++;

					}
					else {noTermino=true;}

					cantidad++;
					if (e==-1) //si no encontre a ninguno mas y es justo termina el texto
					{
						//alert('es -1');
						var new_link = twitbin1.takeUrls(text.substring(s, text.length)); //alert(new_link);

						newtext = newtext + text.substring(anterior, s) + '<a href="#" onclick="twitbin1.openUrl(\'' + new_link + '\');">link &raquo;</a>' +text.substring(s + new_link.length, text.length);

					}
					else {
							var new_link = twitbin1.takeUrls(text.substring(s, e)); //alert(new_link);

							if (anterior==0) //es el primero
							{
								newtext = newtext + text.substring(0, s) + '<a href="#" onclick="twitbin1.openUrl(\'' + new_link + '\');">link &raquo;</a>'+text.substring(s + new_link.length, e);

							}
							else {
						/**/	newtext = newtext + text.substring(anterior, s) + '<a href="#" onclick="twitbin1.openUrl(\'' + new_link + '\');">link &raquo;</a>' +text.substring(s + new_link.length, e);


							}
							anterior=e;
						}

					inicio=e; //o e +1
				}
				else {noTermino=true;}

			}

			if (((e!=text.length) && (e != '')) && (e!= -1))
			{
				newtext = newtext + text.substring(e, text.length);
			}

			if (cantidad!=0)
			{
				return newtext;
				//alert(cantidad);
			}
			else {return text;}

},

takeUsername: function (text)
{
        var pat = /(@(_?))([0-9a-zA-Z\_])+(\:[0-9]+)?(\/([\w#!:.?+=&%@~*\';,\-\/\$])*)?/g;
        var re = /[.,;:]$/;
        while (pat.exec(text) != null) {
          var left = RegExp.leftContext;
          var url = RegExp.lastMatch;
          text = RegExp.rightContext;
          if (re.test(url)) {
            text = RegExp.lastMatch + text;
            url = url.replace(re, '');
          }
        }
        return url;
},

arrobaLink: function(text)
{
			var indice=1; var noTermino=false; var inicio=0; var cantidad=0; var newtext='';
			var anterior=0; var e=''; var s=''; var str="@";
			while (noTermino==false)
			{


				var s = text.indexOf(str, inicio);
				if (s >= 0)
				{	//alert(s);
					e = text.indexOf(" ", s + 1);
					if (e != -1) //no termino el texto
					{

						indice++;

					}
					else {noTermino=true;}

					cantidad++;
					if (e==-1) //si no encontre a ninguno mas y es justo termina el texto
					{
						var new_link = twitbin1.takeUsername(text.substring(s, text.length));

					   //	newtext = newtext + text.substring(anterior, s) + '<a href="#" onclick="twitbin1.openUrl(\'' + new_link + '\');">link &raquo;</a>' +text.substring(s + new_link.length, text.length);

                        if(new_link != undefined){
						    newtext = newtext + text.substring(anterior, s) + '@<a href="#" onclick="twitbin1.openUrl(\'http://twitter.com/' + new_link.substring(1, new_link.length) + '\');">'+new_link.substring(1, new_link.length)+'</a>' +text.substring(s + new_link.length, text.length);
                        }
                        else
                        {
                                newtext = newtext + text.substring(anterior, text.length);
                        }
					}
					else {
							var new_link = twitbin1.takeUsername(text.substring(s, e)); //alert(new_link);

                                                          if(new_link != undefined){
    							if (anterior==0) //es el primero
    							{
    								newtext = newtext + text.substring(0, s) + '@<a href="#" onclick="twitbin1.openUrl(\'http://twitter.com/' + new_link.substring(1, new_link.length) + '\'); ">'+new_link.substring(1, new_link.length)+'</a>' +text.substring(s + new_link.length, e);

    							}
    							else {
    						/**/	newtext = newtext + text.substring(anterior, s) + '@<a href="#" onclick="twitbin1.openUrl(\'http://twitter.com/' + new_link.substring(1, new_link.length) + '\');">'+new_link.substring(1, new_link.length)+'</a>' +text.substring(s + new_link.length, e);
    							}
                            }
                            else{newtext = newtext + text.substring(anterior, e);}

							anterior=e;
						}

					inicio=e; //o e +1
				}
				else {noTermino=true;}

			}

			if (((e!=text.length) && (e != '')) && (e!= -1))
			{
				newtext = newtext + text.substring(e, text.length);
			}

			if (cantidad!=0)
			{
				return newtext;
				//alert(cantidad);
			}
			else {return text;}

},

arrobaLinkNoSeUsa: function(text)
{

			/**/

			var indice=1; var noTermino=false; var inicio=0; var cantidad=0; var newtext=''; var aux="";
			var anterior=0; var e=''; var s='';
			while (noTermino==false)
			{


				s = text.indexOf("@", inicio);
				if (s >= 0)
				{
					if ((((text.substring(s-1, s)).charCodeAt(' ')=="32") || (text.substring(s-1, s) =='')))
					{


						e = text.indexOf(" ", s + 1);
						if (e != -1) //no termino el texto
						{
							indice++;
						}
						else {noTermino=true;}

						cantidad++;
						if (e==-1) //si no encontre a ninguno mas y es justo termina el texto
						{

							var new_link = text.substring(s+1, text.length); //alert(new_link.substring(new_link.length-1, new_link.length));

							//alert(new_link.split(/[\W]+/));

							/**/

							var car=new_link.substring(new_link.length-1, new_link.length);
							var ok3=false;
							var u=0; var ini=0; var fin=1;
							var emp=0; var term=0;
							if (car.search( /[\W]+/) >= 0)
							{

								while ((ok3==false) && (u < new_link.length))
								{
									if ((new_link.substr(ini, fin)).search( /[\W]+/) >=0)
									{ emp= ini; term=fin; ok3=true;}
									else {
										ini++; term++; u++;
									}
								}
							}

							if (car.search( /[\W]+/) == -1)
								{

									newtext = newtext + text.substring(anterior, s) + '@<a href="#" onclick="twitbin1.openUrl(\'http://www.twitter.com/' + new_link + '\');">'+new_link+'</a>';
								}
								else {//si hay algun caracter especial
										newtext = newtext + text.substring(anterior, s) + '@<a href="#" onclick="twitbin1.openUrl(\'http://www.twitter.com/' + new_link.substr(0, ini) + '\');">'+new_link.substr(0, ini)+'</a>' + new_link.substr(ini, fin);
								}

							/**/


						}
						else {
								var new_link = text.substring(s+1, e);


								/**/
								var car=new_link.substring(new_link.length-1, new_link.length);

								var ok3=false;
								var u=0; var ini=0; var fin=1;
								var emp=0; var term=0;
								if (car.search( /[\W]+/) >= 0)
								{

									while ((ok3==false) && (u < new_link.length))
									{
										if ((new_link.substr(ini, fin)).search( /[\W]+/) >=0)
										{ emp= ini; term=fin; ok3=true;}
										else {
											ini++; term++; u++;
										}
									}
								}
								/**/
								if (anterior==0) //es el primero
								{
									if (car.search( /[\W]+/) == -1)
									{
										newtext = newtext + text.substring(0, s) + '@<a href="#" onclick="twitbin1.openUrl(\'http://www.twitter.com/' + new_link + '\');">'+new_link+'</a>';
									}
									else {//si hay algun caracter especial
											newtext = newtext + text.substring(0, s) + '@<a href="#" onclick="twitbin1.openUrl(\'http://www.twitter.com/' + new_link.substr(0, ini) + '\');">'+new_link.substr(0, ini)+'</a>' + new_link.substr(ini, fin);
									}
								}
								else {

										if (car.search( /[\W]+/) == -1)
										{
											newtext = newtext + text.substring(anterior, s) + '@<a href="#" onclick="twitbin1.openUrl(\'http://www.twitter.com/' + new_link + '\');">'+new_link+'</a>';
										}
										else { //si hay algun caracter especial
											newtext = newtext + text.substring(anterior, s) + '@<a href="#" onclick="twitbin1.openUrl(\'http://www.twitter.com/' + new_link.substr(0, ini) + '\');">'+new_link.substr(0, ini)+'</a>' + new_link.substr(ini, fin);
										}
								}
								anterior=e;
						}

						inicio=e; //o e +1
					}else{
							aux=e; //dir del ultimo pedacito de texto
							e = text.indexOf(" ", s + 1);
							if (e!= -1){
											if (text.indexOf("@", s+1)==-1) //no hay mas arrobas
											{
												newtext = newtext + text.substring(inicio, e);
											}

											inicio=e;
							}else{e=aux; noTermino=true;}
						 }

				}//end if (s>=0)
				else{
					//si s no es mayor o igual a 0 es que es =-1

						if (s == -1)
						{
								noTermino=true;
						}

				}//end else


			}//end while

			if (((e!=text.length) && (e != '')) && (e!= -1))
			{
				newtext = newtext + text.substring(e, text.length);
			}

			//alert(cantidad);
			if (cantidad!=0)
			{
				return newtext;
				//alert(cantidad);
			}
			else {return text;}

			/**/

},

//////////////////////////////////////////////////////
//													//
//				  Ajax for stats					//
//													//
//////////////////////////////////////////////////////

getData: function(user)
{
	//usuario;post;public;friend;direct;arroba;fav
	var data=user+";"+twitbin1.generalVeces[1]+";"+ twitbin1.generalVeces[2]+";"+twitbin1.generalVeces[3]+";"+twitbin1.generalVeces[4]+";"+twitbin1.generalVeces[5]+";"+twitbin1.generalVeces[6];

	return data;
},

getReceived: function()
{
	var recList=""; //concateno todos los nros de tweets

	for (var p=0; p < twitbin1.nrosTweets.length; p++)
	{
		if (p==0)
		{
			recList=twitbin1.nrosTweets[p];
		}
		else
		{
			recList=recList+";"+twitbin1.nrosTweets[p];
		}
	}

	return recList;
},

sendStats: function(type)
{
	var user=twitbin1.readCookie("twitbin_user");
    var data= twitbin1.getData(user);
    var rec=twitbin1.getReceived();

    if ((user != null) || (user!= ''))
    {
    	var xhr= $.ajax({

    		url: "http://www.twitbin.com/twitbin20/stats.php?type="+type+"&data="+data+"&user=" + user + "&received=" + rec + "&id="+twitbin1.login_id,

    		type: "GET",
    		beforeSend : function(xhr) { //estado 1
    		},

    		error: function (xhr, textStatus, errorThrown) { //estado 4
    		},
    		processData:false,
    		success: function(datos){	 //estado 4
                    if(type=="login"){twitbin1.login_id=datos;}
    		}


    	}); //end ajax
    }
},

//////////////////////////////////////////////////////
//													//
//			   Firefox conf links in new tabs       //
//													//
//////////////////////////////////////////////////////

 openUrl: function(url) {
   var gBrowser=twitbin1.mainWindow.getBrowser();

   var tab = gBrowser.addTab(url, null, null);
   gBrowser.selectedTab = gBrowser.tabContainer.childNodes[gBrowser.tabContainer.childNodes.length-1];

 },



};  //end Twitbin object

//////////////////////////////////////////////////////
//													//
//			   Firefox conf, http auth pop up       //
//													//
//////////////////////////////////////////////////////


function HttpRequest() {
  this.responseText = "";
  this.status = 0;

  var observer = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
  observer.addObserver(this, "http-on-modify-request", false);
  observer.addObserver(this, "http-on-examine-response", false);
}




HttpRequest.prototype = {

  httpChannel: function() {
    return this.channel.QueryInterface(Components.interfaces.nsIHttpChannel);
  },

  setURI: function(url) {
    this.__url = url;
    var ioService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
    var URI = ioService.newURI(url, null, null);

    this.channel = ioService.newChannelFromURI(URI);
  },

  setRedirectLimitation: function(num) {
    this.httpChannel().redirectionLimit = num;
  },

  asyncOpen: function() {
    this.channel.notificationCallbacks = this;
    this.channel.asyncOpen(this, null);
  },

  setPostData: function(data) {
    var upStream = Components.classes["@mozilla.org/io/string-input-stream;1"].createInstance(Components.interfaces.nsIStringInputStream);
    upStream.setData(data, data.length);
    var upChannel = this.channel.QueryInterface(Components.interfaces.nsIUploadChannel);
    upChannel.setUploadStream(upStream, "application/x-www-form-urlencoded", -1);

    this.httpChannel().requestMethod = "POST"; //alert("entra");
  },

  setRequestHeader: function(header, param) {
    this.httpChannel().setRequestHeader(header, param, true);
  },

  getResponseHeader: function(header) {
    this.httpChannel().getResponseHeader(header);
  },

  setAuthHeader: function(user, pass) {
    this.user = user;
    this.pass = pass;
  },

  abort: function() {
    if (this.timer) {
      this.timer.cancel();
    }
    this.channel.cancel(Components.results.NS_BINDING_ABORTED);
    this.cannnel = null;
  },

  onStartRequest: function(request, context) {
    this.responseText = "";
    try {
      this.status = this.httpChannel().responseStatus;
      this.date   = this.httpChannel().getResponseHeader("Date");
    }
    catch (e) {}
  },

  onDataAvailable: function(request, context, stream, offset, length) {
    var scriptableInputStream =
      Components.classes["@mozilla.org/scriptableinputstream;1"]
        .createInstance(Components.interfaces.nsIScriptableInputStream);
    scriptableInputStream.init(stream);

    this.responseText += scriptableInputStream.read(length);
  },

  onStopRequest: function(request, context, status) {
    if (Components.isSuccessCode(status)) {
      if (this.onload) this.onload(this);
    }
    else if (status != Components.results.NS_BINDING_ABORTED) {
      if (this.onerror) this.onerror(this);
    }
    var observer = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
    observer.removeObserver(this, "http-on-modify-request");
    observer.removeObserver(this, "http-on-examine-response");
  },

  onChannelRedirect: function(oldChannel, newChannel, flags) {
    if (this._onredirect) {
      this._onredirect(oldChannel, newChannel, flags);
    }
    else {
      this.channel = newChannel;
    }
  },

  observe: function(subject, topic, data) {
    // Do not use user cookies
    //
    if (subject == this.channel) {
      if (topic == "http-on-modify-request") {
        this.httpChannel().setRequestHeader("Cookie", "", false);
      }
      else if (topic == "http-on-examine-response") {
        this.httpChannel().setResponseHeader("Set-Cookie", "", false);
      }

      if (topic == "http-on-modify-request" && this.user) {
        this.httpChannel().setRequestHeader("Authorization", Twitbin.make_base_auth() , false);
      }
    }
  },

  // nsIInterfaceRequestor
  getInterface: function(aIID) {
    try {
      return this.QueryInterface(aIID);
    }
    catch (e) {
      throw Components.results.NS_NOINTERFACE;
    }
  },

  // nsIProgressEventSink (to shut up annoying debug exceptions
  onProgress: function(request, context, progress, progressmax) {},
  onStatus: function(request, context, status, statusArg) {},

  // nsIHttpEventSink (to shut up annoying debug exceptions
  onRedirect: function(oldChannel, newChannel) {},

  // nsIAuthPromptProvider (to shut up annoying debug exceptions
  getAuthPrompt: function(reason) {},

  QueryInterface: function(aIID) {
    if (aIID.equals(Components.interfaces.nsISupports) ||
        aIID.equals(Components.interfaces.nsIObserver) ||
        aIID.equals(Components.interfaces.nsISupportsWeakReference) ||
        aIID.equals(Components.interfaces.nsIWebProgress) ||
        aIID.equals(Components.interfaces.nsIDocShell) ||
        aIID.equals(Components.interfaces.nsIDocShellTreeItem) ||
        aIID.equals(Components.interfaces.nsIPrompt) ||
        aIID.equals(Components.interfaces.nsIAuthPrompt) ||
        aIID.equals(Components.interfaces.nsIAuthPromptProvider) ||
        aIID.equals(Components.interfaces.nsIInterfaceRequestor) ||
        aIID.equals(Components.interfaces.nsIChannelEventSink) ||
        aIID.equals(Components.interfaces.nsIProgressEventSink) ||
        aIID.equals(Components.interfaces.nsIHttpEventSink) ||
        aIID.equals(Components.interfaces.nsIStreamListener))
      return this;

    throw Components.results.NS_NOINTERFACE;
  }
};
